Package: calmate
Version: 0.13.0
Depends: R (>= 3.2.1), R.utils (>= 2.11.0), aroma.core (>= 3.2.2)
Imports: utils, MASS, R.methodsS3 (>= 1.8.1), R.oo (>= 1.24.0),
        matrixStats (>= 0.61.0), R.filesets (>= 2.14.0)
Suggests: DNAcopy
Title: Improved Allele-Specific Copy Number of SNP Microarrays for
        Downstream Segmentation
Description: The CalMaTe method calibrates preprocessed allele-specific copy number estimates (ASCNs) from DNA microarrays by controlling for single-nucleotide polymorphism-specific allelic crosstalk. The resulting ASCNs are on average more accurate, which increases the power of segmentation methods for detecting changes between copy number states in tumor studies including copy neutral loss of heterozygosity. CalMaTe applies to any ASCNs regardless of preprocessing method and microarray technology, e.g. Affymetrix and Illumina.
Authors@R: c(
  person("Maria", "Ortiz", role=c("aut", "ctb")),
  person("Ander", "Aramburu", role=c("ctb")),
  person("Henrik", "Bengtsson", role=c("aut", "cre", "cph"),
                                 email="henrikb@braju.com"),
  person("Pierre", "Neuvial", role=c("aut", "ctb")),
  person("Angel", "Rubio", role=c("aut", "ctb")))
License: LGPL (>= 2.1)
URL: https://github.com/HenrikBengtsson/calmate/
BugReports: https://github.com/HenrikBengtsson/calmate/issues
LazyLoad: TRUE
biocViews: aCGH, CopyNumberVariants, SNP, Microarray, OneChannel,
        TwoChannel, Genetics
NeedsCompilation: no
Packaged: 2022-03-08 19:16:14 UTC; hb
Author: Maria Ortiz [aut, ctb],
  Ander Aramburu [ctb],
  Henrik Bengtsson [aut, cre, cph],
  Pierre Neuvial [aut, ctb],
  Angel Rubio [aut, ctb]
Maintainer: Henrik Bengtsson <henrikb@braju.com>
Repository: CRAN
Date/Publication: 2022-03-08 23:00:03 UTC
Built: R 4.6.0; ; 2026-04-26 11:58:24 UTC; unix

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# IMPORTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
importFrom("R.methodsS3", "setMethodS3")
importFrom("R.oo", "setConstructorS3")
importFrom("R.oo", "extend")
importFrom("R.oo", "uses")

## Importing Class:es
importFrom("R.oo", "Object")
importFrom("R.oo", "Package")


## Importing generics
importFrom("aroma.core", "findUnitsTodo")
importFrom("aroma.core", "getParameters")
importFrom("aroma.core", "getRootPath")
importFrom("aroma.core", "process")
importFrom("R.filesets", "getAsteriskTags")
importFrom("R.filesets", "getFullName")
importFrom("R.filesets", "getTags")
importFrom("R.filesets", "nbrOfFiles")
importFrom("R.filesets", "setTags")
importFrom("R.filesets", "getName") ## Multi-sources: R.oo, R.filesets
importFrom("R.filesets", "getPath") ## Multi-sources: R.oo, R.filesets

## Importing functions
importFrom("aroma.core", "getChipType")
importFrom("aroma.core", "getParametersAsString")
importFrom("aroma.core", "getRam")
importFrom("aroma.core", "processTime")
importFrom("MASS", "rlm")
importFrom("matrixStats", "rowAlls")
importFrom("matrixStats", "rowMedians")
importFrom("R.filesets", "byPath")
importFrom("R.filesets", "extractMatrix")
importFrom("R.filesets", "getFile")
importFrom("R.filesets", "getFullNames")
importFrom("R.filesets", "getNames")
importFrom("R.filesets", "getPathname")
importFrom("R.filesets", "indexOf")
importFrom("R.oo", "throw")
importFrom("R.oo", "newInstance")
importFrom("R.oo", "startupMessage")
importFrom("R.oo", "trim")
importFrom("R.utils", "capitalize")
importFrom("R.utils", "cat") ## Multi-sources: R.utils, base
importFrom("R.utils", "copyFile")
importFrom("R.utils", "enter")
importFrom("R.utils", "exit")
importFrom("R.utils", "filePath")
importFrom("R.utils", "getAbsolutePath")
importFrom("R.utils", "isDirectory")
importFrom("R.utils", "isFile") ## Multi-sources: R.utils, R.filesets
importFrom("R.utils", "less")
importFrom("R.utils", "mkdirs")
importFrom("R.utils", "popState")
importFrom("R.utils", "popTemporaryFile")
importFrom("R.utils", "printf")
importFrom("R.utils", "pushState")
importFrom("R.utils", "pushTemporaryFile")
importFrom("R.utils", "writeRaw")

importFrom("stats", "median", "pnorm")
importFrom("utils", "str")
importFrom("utils", "sessionInfo")

## Manually adjusted
importFrom("R.filesets", "extract") ## Multi-sources: R.utils, R.filesets
importFrom("R.filesets", "getFilename") ## Multi-sources: R.utils, R.filesets
## Cannot import explicitly from 'base';
## importFrom("base", "colSums") ## Multi-sources: aroma.core, base


# Manual imports
importFrom("aroma.core", "aromaSettings")
importFrom("R.utils", "Arguments")


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# EXPORTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Export all public methods, that is, those without a preceeding dot
# in their names.
exportPattern("^[^\\.]")


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# DECLARATIONS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# array
S3method("calmateByThetaAB", "array")
S3method("calmateByTotalAndFracB", "array")
S3method("thetaAB2TotalAndFracB", "array")
S3method("totalAndFracB2ThetaAB", "array")
S3method("truncateFracB", "array")
S3method("truncateThetaAB", "array")

# CalMaTeCalibration
S3method("allocateOutputDataSets", "CalMaTeCalibration")
S3method("as.character", "CalMaTeCalibration");
S3method("findUnitsTodo", "CalMaTeCalibration")
S3method("getAsteriskTags", "CalMaTeCalibration");
S3method("getDataSets", "CalMaTeCalibration")
S3method("getFullName", "CalMaTeCalibration")
S3method("getName", "CalMaTeCalibration")
S3method("getOutputDataSets", "CalMaTeCalibration")
S3method("getParameters", "CalMaTeCalibration")
S3method("getPath", "CalMaTeCalibration")
S3method("getReferences", "CalMaTeCalibration")
S3method("getRootPath", "CalMaTeCalibration")
S3method("getTags", "CalMaTeCalibration")
S3method("nbrOfFiles", "CalMaTeCalibration")
S3method("process", "CalMaTeCalibration")
S3method("setTags", "CalMaTeCalibration")

# matrix
S3method("fitCalMaTe", "matrix")
S3method("fitCalMaTeCNprobes", "matrix")
S3method("truncateFracB", "matrix")
S3method("truncateThetaAB", "matrix")

<div id="badges"><!-- pkgdown markup -->
<a href="https://CRAN.R-project.org/web/checks/check_results_calmate.html"><img border="0" src="https://www.r-pkg.org/badges/version/calmate" alt="CRAN check status"/></a> <a href="https://github.com/HenrikBengtsson/calmate/actions?query=workflow%3AR-CMD-check"><img border="0" src="https://github.com/HenrikBengtsson/calmate/actions/workflows/R-CMD-check.yaml/badge.svg?branch=develop" alt="R CMD check status"/></a>     <a href="https://app.codecov.io/gh/HenrikBengtsson/calmate"><img border="0" src="https://codecov.io/gh/HenrikBengtsson/calmate/branch/develop/graph/badge.svg" alt="Coverage Status"/></a> 
</div>

# calmate: Improved Allele-Specific Copy Number of SNP Microarrays for Downstream Segmentation 

The CalMaTe method calibrates preprocessed allele-specific copy number estimates (ASCNs) from DNA microarrays by controlling for single-nucleotide polymorphism-specific allelic crosstalk. The resulting ASCNs are on average more accurate, which increases the power of segmentation methods for detecting changes between copy number states in tumor studies including copy neutral loss of heterozygosity. CalMaTe applies to any ASCNs regardless of preprocessing method and microarray technology, e.g. Affymetrix and Illumina.


## Citing calmate

Whenever using the **calmate** package or the CalMaTe method, please cite:

* M. Ortiz-Estevez, A. Aramburu, H. Bengtsson, P. Neuvial, and A. Rubio, CalMaTe: A method and software to improve allele-specific copy number of SNP arrays for downstream segmentation, Bioinformatics, Volume 28, Issue 13, 2012, Pages 1793-1794, [doi:10.1093/bioinformatics/bts248](https://doi.org/10.1093/bioinformatics/bts248)

## Installation
R package calmate is available on [CRAN](https://cran.r-project.org/package=calmate) and can be installed in R as:
```r
install.packages("calmate")
```


### Pre-release version

To install the pre-release version that is available in Git branch `develop` on GitHub, use:
```r
remotes::install_github("HenrikBengtsson/calmate", ref="develop")
```
This will install the package from source.  

###########################################################################
# Title:
# Author: Henrik Bengtsson
###########################################################################


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Loading support files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Find the pathname and directory of this script
library("R.utils");
pathname <- names(findSourceTraceback())[1];
path <- dirname(pathname);

# Loading include files
pathT <- file.path(path, "R/");
sourceDirectory(path=pathT);

anTags <- c("dens", "hets");

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calibrated or not?
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
calTag <- textMenu(calTags, title="Choose calibration method:", value=TRUE);
if (calTag == "<none>") calTag <- NULL;



dsList <- loadSets(dataSet, tags=c(tags, calTag), chipType=chipType, verbose=verbose);
verbose && print(verbose, dsList);

# Sanity check
# stopifnot(all(sapply(dsList, FUN=length) == 40));


# Translated data set tags
dsTags <- tags(fullname(dataSet, getTags(dsList[[1]])));
dsTags <- gsub("ACC,-XY,BPN,-XY,RMA,FLN,-XY", "ASCRMAv2", dsTags);
dsTags <- gsub("ACC,-XY,BPN,-XY,AVG,FLN,-XY", "ASCRMAv2", dsTags);
dsTags <- gsub("CMTN", "CalMaTe", dsTags);
dsTags <- dropTags(dsTags, drop="refs=N");


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extracting one tumor-normal pair
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
verbose && enter(verbose, "Extracting tumor-normal pair of interest");
pairs <- getPairs(dsList);
pair <- pairs[sampleName,,drop=TRUE];
verbose && cat(verbose, "Tumor: ", pair["tumor"]);
verbose && cat(verbose, "Normal: ", pair["normal"]);
pairName <- paste(pair, collapse="vs");
verbose && cat(verbose, "Pair: ", pairName);
verbose && exit(verbose);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segments to be studied
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
for (kk in seq_along(segments)) {
  segName <- names(segments)[kk];
  segment <- segments[[segName]];
  chr <- segment[1];
  region <- segment[2:3];

  chrTag <- sprintf("chr%02d", chr);
  segTag <- sprintf("%s:%g-%gMb", chrTag, region[1], region[2]);

  verbose && enter(verbose, sprintf("Segment #%d ('%s') of %d", kk, segTag, length(segments)));

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extracting signals
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  dataList <- lapply(pair, FUN=function(name) {
    extractSignals(dsList, sampleName=name, chromosome=chr, region=region*1e6, verbose=verbose);
  });
  names(dataList) <- names(pair);

  # Extract (gammaT, gammaN)
  gammaT <- getSignals(dataList$tumor$tcn);
  gammaN <- getSignals(dataList$normal$tcn);

  # Extract (betaT, betaN)
  betaT <- getSignals(dataList$tumor$baf);
  betaN <- getSignals(dataList$normal$baf);
  muN <- callNaiveGenotypes(betaN);
  x <- dataList$normal$tcn$x / 1e6;

  col <- "black";
  if (is.element("hets", anTags)) {
    col <- rep(col, times=length(muN));
    col[muN != 1/2] <- hetCol;
  }

  for (tbn in c(FALSE, TRUE)) {
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Plot (betaN,betaT)
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    beta <- cbind(N=betaN, T=betaT);

    tagsT <- dsTags;
    if (tbn) {
      verbose && enter(verbose, "TumorBoosting");
      betaTN <- normalizeTumorBoost(betaT=betaT, betaN=betaN);
      verbose && str(verbose, betaTN);
      verbose && exit(verbose);
      beta[,"T"] <- betaTN;
      tagsT <- fullname(tagsT, "TBN");
    }

    ascn <- cbind(A=(1-beta[,"T"])*gammaT, B=beta[,"T"]*gammaT);

    tags <- c(gsub(":","_",segTag), tagsT, "BvsB", anTags);
    toPNG(name=sampleName, tags=tags, width=840, {
      plotBvsB(beta, col=col, sampleName=sampleName, segName=segName, segTag=segTag, dataSet=dataSet, tagsT=tagsT, chipType=chipType);
    })

    tags <- c(gsub(":","_",segTag), tagsT, "ASCN", anTags);
    toPNG(name=sampleName, tags=tags, width=840, {
      plotASCN(ascn, col=col, sampleName=sampleName, segName=segName, segTag=segTag, dataSet=dataSet, tagsT=tagsT, chipType=chipType);
    })

    tags <- c(gsub(":","_",segTag), tagsT, "BvsC", anTags);
    toPNG(name=sampleName, tags=tags, width=840, {
      plotCvsB(ascn, col=col, sampleName=sampleName, segName=segName, segTag=segTag, dataSet=dataSet, tagsT=tagsT, chipType=chipType);
    })


    tags <- c(chrTag, tagsT, "TCN", anTags);
    toPNG(name=sampleName, tags=tags, width=840, height=300, {
      plotTrackTCN(gammaT, x=x, cex=2, col=col, sampleName=sampleName, chrTag=chrTag, dataSet=dataSet, tagsT=tagsT, chipType=chipType);
    });

    tags <- c(chrTag, tagsT, "BAFT", anTags);
    toPNG(name=sampleName, tags=tags, width=840, height=300, {
      plotTrackBAF(beta[,"T"], x=x, cex=2, col=col, sampleName=sampleName, chrTag=chrTag, dataSet=dataSet, tagsT=tagsT, chipType=chipType);
    });

    tags <- c(chrTag, tagsT, "BAFN", anTags);
    toPNG(name=sampleName, tags=tags, width=840, height=300, {
      plotTrackBAF(beta[,"N"], x=x, cex=2, col=col, sampleName=sampleName, chrTag=chrTag, dataSet=dataSet, tagsT=tagsT, chipType=chipType);
    });

    tags <- c(chrTag, tagsT, "DH", anTags);
    toPNG(name=sampleName, tags=tags, width=840, height=300, {
      plotTrackDH(beta[,"T"], x=x, muN=muN, cex=2, col=col, sampleName=sampleName, chrTag=chrTag, dataSet=dataSet, tagsT=tagsT, chipType=chipType);
    });

    tags <- c(gsub(":","_",segTag), tagsT, "C1C2", anTags);
    toPNG(name=sampleName, tags=tags, width=840, height=300, {
      plotTrackC1C2(ascn, x=x, muN=muN, cex=2, sampleName=sampleName, segName=segName, segTag=segTag, dataSet=dataSet, tagsT=tagsT, chipType=chipType);
    })

    tags <- c(gsub(":","_",segTag), tagsT, "C1C2", "smooth", anTags);
    toPNG(name=sampleName, tags=tags, width=840, height=300, {
      plotTrackC1C2(ascn, x=x, muN=muN, cex=2, smooth="2Mb", sampleName=sampleName, segName=segName, segTag=segTag, dataSet=dataSet, tagsT=tagsT, chipType=chipType);
    })
  } # for (tbn ...)

  verbose && exit(verbose);
} # for (kk ...)



###########################################################################
# HISTORY:
# 2011-03-09 [HB]
# o Created from PN's code in the online vignette.
###########################################################################

###########################################################################
# Title:
# Author: Henrik Bengtsson
###########################################################################


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Loading support files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Find the pathname and directory of this script
library("R.utils");
pathname <- names(findSourceTraceback())[1];
path <- dirname(pathname);

# Loading include files
sourceTo("001.include.R", path=path);
#sourceTo("002.datasets.R", path=path);


figPath <- file.path("figures");
figPath <- Arguments$getWritablePath(figPath);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Choose data set & chip type
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
rootPath <- "totalAndFracBData";
rootPath <- Arguments$getReadablePath(rootPath);
dataSets <- list.files(path=rootPath, full.names=FALSE, all.files=FALSE);

# Skip already process data sets
##keep <- grep(",CMTN", dataSets, invert=TRUE);
## dataSets <- dataSets[keep];

if (length(chipTypes) == 0) {
  throw("No data sets available: ", path);
}
dataSet <- textMenu(dataSets, title="Choose data set:", value=TRUE);


path <- file.path(rootPath, dataSet);
path <- Arguments$getReadablePath(path, mustExist=TRUE);
chipTypes <- list.files(path=path, full.names=FALSE, all.files=FALSE);
if (length(chipTypes) == 0) {
  throw("No chip types available for this data set: ", path);
}
if (length(chipTypes) == 1) {
  chipType <- chipTypes[1];
} else {
  chipType <- textMenu(chipTypes, title="Choose chip type:", value=TRUE);
}


dsList <- loadSets(dataSet, chipType=chipType, verbose=verbose);
verbose && print(verbose, dsList);

dsTags <- getTags(dsList$total, collapse=",");
dsTags <- gsub("ACC(|,ra)-XY,BPN,-XY,RMA,FLN,-XY", "ASCRMAv2", dsTags);
dsTags <- gsub("ACC(|,ra),-XY,BPN,-XY,AVG,FLN,-XY", "ASCRMAv2", dsTags);
dsTags <- gsub("CMTN", "CalMaTe", dsTags);


ugp <- getAromaUgpFile(dsList$total);
print(ugp);

chromosomes <- getChromosomes(ugp)[19:20];
print(chromosomes);

sampleNames <- getNames(dsList$total)[1];
print(sampleNames);

col <- "#999999";

dataSetT <- paste(c(getName(dsList[[1]]), dsTags), collapse=",");
figPathT <- file.path(figPath, dataSetT, chipType);
figPathT <- Arguments$getWritablePath(figPathT);

for (ii in seq_along(sampleNames)) {
  sampleName <- sampleNames[ii];
  verbose && enter(verbose, sprintf("Sample #%d ('%s') of %d", ii, sampleName, length(sampleNames)));

  for (kk in seq_along(chromosomes)) {
    chr <- chromosomes[kk];
    chrTag <- sprintf("chr%02d", chr);

    verbose && enter(verbose, sprintf("Chromosome #%d ('%s') of %d", kk, chrTag, length(chromosomes)));

    data <- extractSignals(dsList, sampleName=sampleName, chromosome=chr, verbose=verbose);
    verbose && print(verbose, data);

    # Extract (gamma, beta)
    gamma <- getSignals(data$tcn);
    beta <- getSignals(data$baf);
    x <- data$tcn$x / 1e6;

    fullname <- fullname(sampleName, chrTag, "TCN");
    devEval("png", name=fullname, width=840, height=300, {
      plotTrackTCN(gamma, x=x, col=col, sampleName=sampleName, chrTag=chrTag, dataSet=dataSet, chipType=chipType);
    }, path=figPathT);

    fullname <- fullname(sampleName, chrTag, "BAF");
    devEval("png", name=fullname, width=840, height=300, {
      plotTrackBAF(beta, x=x, col=col, sampleName=sampleName, chrTag=chrTag, dataSet=dataSet, chipType=chipType);
    }, path=figPathT);

    verbose && exit(verbose);
  } # for (kk ...)

  verbose && exit(verbose);
} # for (ii ...)



###########################################################################
# HISTORY:
# 2011-08-01 [HB]
# o Now the figures are written to a data-set specific directory.
# o BUG FIX: Forgot to define 'col'.
# 2011-03-14 [HB]
# o Created.
###########################################################################

###########################################################################
# Author: Henrik Bengtsson
# Created on: 2012-02-06
# Last updated: 2012-02-06
#
# Data:
# rawData/GSE8605/Mapping10K_Xba142/
#
# URL: http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE12702
###########################################################################

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CalMaTe
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
library("calmate");
verbose <- Arguments$getVerbose(-10, timestamp=TRUE);

dataSet <- "GSE8605";
chipType <- "Mapping10K_Xba142";
tags <- "ACC,-XY,BPN,-XY,RMA,FLN,-XY";
dsT <- AromaUnitTotalCnBinarySet$byName(dataSet, tags=tags, chipType=chipType);
dsB <- AromaUnitFracBCnBinarySet$byName(dataSet, tags=tags, chipType=chipType);
dsList <- list(total=dsT, fracB=dsB);
print(dsList);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CalMaTe
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
asn <- CalMaTeCalibration(dsList, fB1=0.33, fB2=0.66);
print(asn);

dsNList <- process(asn, verbose=verbose);
print(dsNList);

stop();

ugp <- getAromaUgpFile(dsT);
chr <- 17;
units <- getUnitsOnChromosome(ugp, chr);


# Array #ii
ii <- 1;

# Extract raw (TCN,BAF)
df <- getFile(dsList$total, ii);
dfR <- getAverageFile(dsList$total, verbose=verbose);
gamma <- extractRawCopyNumbers(df, logBase=NULL, chromosome=chr);
gammaR <- extractRawCopyNumbers(dfR, logBase=NULL, chromosome=chr);
gamma <- 2*divideBy(gamma, gammaR);
df <- getFile(dsList$fracB, ii);
beta <- extractRawAlleleBFractions(df, chromosome=chr);

# Extract calibrated (TCN,BAF)
dfN <- getFile(dsNList$fracB, ii);
betaN <- extractRawAlleleBFractions(dfN, chromosome=chr);
dfN <- getFile(dsNList$total, ii);
gammaN <- extractRawCopyNumbers(dfN, logBase=NULL, chromosome=chr);

# Plot
subplots(4, ncol=2, byrow=FALSE);
plot(beta);
title(sprintf("%s", getName(beta)));
plot(gamma);
plot(betaN);
title(sprintf("%s (CalMaTe)", getName(betaN)));
plot(gammaN);


###########################################################################
# HISTORY:
# 2010-09-28
# o Added total CN track.
# o Using CalMaTeCalibration formely known CalMaTeNormalization.
# 2010-06-20
# o Created.
###########################################################################

###########################################################################
# Title:
#
# Author: Henrik Bengtsson
# 
# Requirements:
###########################################################################

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Loading support files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Find the pathname and directory of this script
library("R.utils");
pathname <- names(findSourceTraceback())[1];
path <- dirname(pathname);

# Loading include files
sourceTo("R/001.include.R", path=path);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setting up data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE12702";
tags <- "ACC,-XY,BPN,-XY,RMA,FLN,-XY";
chipType <- "Mapping250K_Nsp";

dsList <- loadSets(dataSet, tags=tags, chipType=chipType, verbose=verbose);
verbose && print(verbose, dsList);

# Sanity check
stopifnot(length(dsList$total) == 40);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CalMaTe
#
# Alternatives:
# 1. "blind" CalMaTe (using all arrays as references)
# 2. Clever CalMaTe (using normal arrays as references)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
verbose && enter(verbose, "Normalization ASCNs using CalMaTe");

flavor <- c("v1", "v2")[1];
verbose && cat(verbose, "Flavor: ", flavor);

useNormalRefs <- TRUE;
if (useNormalRefs) {
  # Identify the 20 tumor-normal pairs
  patientIDs <- c(24, 25, 27, 31, 45, 52, 58, 60, 75, 110, 115, 122, 128, 137, 138, 140, 154, 167, 80, 96);

  sampleTypes <- c("tumor", "normal");
  ids <- rep(patientIDs, each=length(sampleTypes));
  types <- rep(sampleTypes, times=length(patientIDs));
  ad <- data.frame(patient=ids, type=types, name=getNames(dsList$total));

  # Identify the 20 normal samples
  refs <- which(ad$type == "normal");
  verbose && cat(verbose, "Number of reference samples for CalMaTe: ", length(refs));

  # Sanity check
  stopifnot(length(refs) == 20);

  refTag <- "refs=N";
} else {
  refs <- NULL;
  refTag <- NULL;
}


## CalMaTe calibration
cmt <- CalMaTeCalibration(dsList, references=refs, flavor=flavor, tags=c("*", refTag));
verbose && print(verbose, cmt);

dsCList <- process(cmt, verbose=verbose);

dsCList <- getOutputDataSets(cmt);
verbose && print(verbose, dsCList);

verbose && exit(verbose);



###########################################################################
# HISTORY:
# 2012-02-19 [HB]
# o Now supporting CalMaTe 'flavor' (calmate >= v0.8.0).
# 2011-03-09 [HB]
# o Created from other scripts and online CalMaTe vignette.
###########################################################################

###########################################################################
# Title:
# Author: Henrik Bengtsson
###########################################################################


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Loading support files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Find the pathname and directory of this script
library("R.utils");
pathname <- names(findSourceTraceback())[1];
path <- dirname(pathname);

# Loading include files
pathT <- file.path(path, "R/");
sourceDirectory(path=pathT);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calibrated or not?
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
calTag <- textMenu(calTags, title="Choose calibration method:", value=TRUE);
if (calTag == "<none>") calTag <- NULL;


dsList <- loadSets(dataSet, tags=c(tags, calTag), chipType=chipType, verbose=verbose);
verbose && print(verbose, dsList);

# Sanity check
# stopifnot(all(sapply(dsList, FUN=length) == 40));


# Translated data set tags
dsTags <- tags(fullname(dataSet, getTags(dsList[[1]])));
dsTags <- gsub("ACC,-XY,BPN,-XY,RMA,FLN,-XY", "ASCRMAv2", dsTags);
dsTags <- gsub("ACC,-XY,BPN,-XY,AVG,FLN,-XY", "ASCRMAv2", dsTags);
dsTags <- gsub("CMTN", "CalMaTe", dsTags);
dsTags <- dropTags(dsTags, drop="refs=N");


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Extracting signals
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
units <- 1000+1:100;
dd <- extractCACB(dsList, units=units);

tagsT <- dsTags;
for (uu in seq_along(units)) {
  unit <- units[uu];
  unitTag <- sprintf("unit%06d", unit);
  unitName <- unit;

  ddT <- dd[uu,,];

  tags <- c(tagsT, unitTag, "CACB");
  toPNG(name=sampleName, tags=tags, width=840, {
    plotMultiArrayCACB(ddT, unitName=unitName, tagsT=tagsT);
  });
} # for (uu ...)


###########################################################################
# HISTORY:
# 2011-03-10 [HB]
# o Created.
###########################################################################

###########################################################################
# Title:
# Author: Henrik Bengtsson
###########################################################################

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Loading support files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Find the pathname and directory of this script
library("R.utils");
pathname <- names(findSourceTraceback())[1];
path <- dirname(pathname);

# Loading include files
sourceTo("R/001.include.R", path=path);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Choose chip type to study
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
chipTypes <- c("GenomeWideSNP_6", "Human1M-Duo");
if (interactive() && require("R.menu")) {
  chipType <- textMenu(chipTypes, title="Select chip type:", value=TRUE);
} else {
  chipType <- chipTypes[1];
}


figPath <- file.path("figures", chipType);
figPath <- Arguments$getWritablePath(figPath);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setting up data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (chipType == "Human1M-Duo") {
  dataSet <- "hudsonalpha.org_OV.Human1MDuo.1.1.0";
  tags <- "XY";
  chipType <- "Human1M-Duo"
} else if (chipType == "GenomeWideSNP_6") {
  dataSet <- "broad.mit.edu_OV.Genome_Wide_SNP_6.12.6.0";
  tags <- "ASCRMAv2";
  chipType <- "GenomeWideSNP_6";
}

dsList <- loadSets(dataSet, tags=tags, chipType=chipType, verbose=verbose);
verbose && print(verbose, dsList);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CalMaTe
#
# Alternatives:
# 1. "blind" CalMaTe (using all arrays as references)
# 2. Clever CalMaTe (using normal arrays as references)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
verbose && enter(verbose, "Normalization ASCNs using CalMaTe");

flavor <- c("v1", "v2")[2];
verbose && cat(verbose, "Flavor: ", flavor);

useNormalRefs <- TRUE;
if (useNormalRefs) {
  ## Identify the normal samples to be used as references
  refs <- grep("-(10|11)[A-Z]-", getFullNames(dsList$total));
  # stopifnot(length(refs) == length(dsList$total)/2);
  verbose && cat(verbose, "Number of reference samples for CalMaTe: ", length(refs));
  refTag <- "refs=N";
} else {
  refs <- NULL;
  refTag <- NULL;
}


## CalMaTe calibration
cmt <- CalMaTeCalibration(dsList, references=refs, flavor=flavor, tags=c("*", refTag));
verbose && print(verbose, cmt);

dsCList <- process(cmt, verbose=verbose);

dsCList <- getOutputDataSets(cmt);
verbose && print(verbose, dsCList);
verbose && exit(verbose);



###########################################################################
# HISTORY:
# 2012-02-19 [HB]
# o Now expliticly specifying argument 'flavor' of CalMaTeCalibration,
#   which was introduced in calmate v0.8.0.
# 2011-03-09 [HB]
# o Created from PN's CalMaTe,Illumina.R script from Nov 2010.
###########################################################################

###########################################################################
# 001.include.R
#
# Author: Henrik Bengtsson
# 
# Description:
# This script defines functions and other objects that are needed by
# all scripts in this directory.
###########################################################################
library("aroma.cn");
library("calmate");
verbose <- Arguments$getVerbose(-10, timestamp=TRUE);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Local functions
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
loadSets <- function(..., verbose=FALSE) {
  dsT <- AromaUnitTotalCnBinarySet$byName(..., verbose=verbose);
  dsB <- AromaUnitFracBCnBinarySet$byName(..., verbose=verbose);
  list(total=dsT, fracB=dsB);
} # loadSets()



extractSignals <- function(dsList, sampleName, ..., reference=c("auto", "none", "median"), verbose=FALSE) {
  # Argument 'reference':
  reference <- match.arg(reference);

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose);
  if (verbose) {
    pushState(verbose);
    on.exit(popState(verbose));
  }

  verbose && enter(verbose, "Extracting total CN signals");
  
  verbose && enter(verbose, "Extracting sample of interest");
  verbose && cat(verbose, "Sample name: ", sampleName);
  
  idxT <- indexOf(dsList$total, sampleName);
  dfT <- getFile(dsList$total, idxT);
  idxB <- indexOf(dsList$fracB, sampleName);
  dfB <- getFile(dsList$fracB, idxB);
  
  verbose && print(verbose, list(tumor=dfT, fracB=dfB));
  verbose && exit(verbose);
  
  verbose && enter(verbose, "Extracting TCNs");
  tcn <- extractRawCopyNumbers(dfT, logBase=NULL, ...);
  verbose && print(verbose, tcn);
  verbose && exit(verbose);

  verbose && enter(verbose, "Extracting BAFs");
  baf <- extractRawAlleleBFractions(dfB, ...);
  verbose && print(verbose, baf);
  verbose && exit(verbose);

  if (reference == "auto") {
    verbose && enter(verbose, "Inferring from data set name if CN ratios needs to be calculated");
    hasRatios <- hasTag(dsList$total, "CMTN");
    verbose && cat(verbose, "Has 'CMTN' tag: ", hasRatios);
    reference <- ifelse(hasRatios, "none", "median");
    verbose && cat(verbose, "Inferred argument 'reference': ", reference);
    verbose && exit(verbose);
  }
  
  if (reference == "median") {
    dfTR <- getAverageFile(dsList$total, verbose=less(verbose,5));
    
    verbose && enter(verbose, "Extracting TCNs for reference pool");
    tcnR <- extractRawCopyNumbers(dfTR, logBase=NULL, ...);
    verbose && print(verbose, tcnR);
    verbose && exit(verbose);
    
    tcn <- divideBy(tcn, tcnR);
    tcn$y <- 2*tcn$y;
  }
  
  res <- list(tcn=tcn, baf=baf);
  verbose && exit(verbose);
  
  res;
} # extractSignals()


plotBvsB <- function(beta, col=NULL, pch=19, Blim=c(-0.2,+1.2), xlab="Normal BAF", ylab="Tumor BAF", dataSet=NULL, chipType=NULL, sampleName=NULL, chrTag=NULL, segName=NULL, segTag=NULL, tagsT=NULL, ...) {
  par(mar=c(5.8,7,3,3)+0.1, mgp=c(4,1.4,0), cex=0.8, cex.lab=3.8, cex.axis=2.8);
  plot(NA, xlim=Blim, ylim=Blim, xlab=xlab, ylab=ylab, axes=FALSE);
  for (ss in 1:2) {
    axis(side=ss, at=c(0,1/2,1), label=c("0","1/2","1"));
  }
  box();
  abline(a=0, b=1, lty=3, lwd=2);

  # Text annotations
  if (!is.null(chrTag)) {
    stext(side=3, pos=0, chrTag,  cex=1.5);
  } else if (!is.null(segName) & !is.null(segTag)) {
    stext(side=3, pos=0, sprintf("%s @ %s", segName, segTag), cex=2.0);
  }
  if (!is.null(tagsT)) {
    tagsT <- fullname(tagsT);
    stext(side=3, pos=1, tagsT, cex=2.0);
  }
  if (!is.null(dataSet) & !is.null(chipType)) {
    stext(side=4, pos=0, sprintf("%s (%s)", dataSet, chipType), cex=1.5);
  }
  if (!is.null(sampleName)) {
    stext(side=4, pos=1, sampleName,  cex=1.5);
  }

  points(beta, pch=pch, col=col, cex=1);

  if (is.element("dens", anTags)) {
    for (dd in 1:2) {
      d <- density(beta[,dd], adjust=0.4, from=Blim[1], to=Blim[2], na.rm=TRUE);
      draw(d, lwd=3, col="#666666", side=dd, 
                       height=0.05, scale="relative", xpd=FALSE);
    }
  }
} # plotBvsB()



plotASCN <- function(ascn, col=NULL, pch=19, Clim=c(-0.4,4), xlab=expression(C[A]), ylab=expression(C[B]), dataSet=NULL, chipType=NULL, sampleName=NULL, chrTag=NULL, segName=NULL, segTag=NULL, tagsT=NULL, ...) {
#  par(mar=c(4,5,3,3)+0.1, cex=0.8, cex.lab=2.4, cex.axis=2.2);
  par(mar=c(5.8,7,3,3)+0.1, mgp=c(4,1.4,0), cex=0.8, cex.lab=3.8, cex.axis=2.8);
  plot(NA, xlim=Clim, ylim=Clim, xlab=xlab, ylab=ylab, axes=FALSE);
  for (ss in 1:2) {
    axis(side=ss, at=0:round(max(Clim)+1L));
  }
  box();
  abline(a=0, b=1, lty=3, lwd=2);

  # Text annotations
  if (!is.null(chrTag)) {
    stext(side=3, pos=0, chrTag,  cex=1.5);
  } else if (!is.null(segName) & !is.null(segTag)) {
    stext(side=3, pos=0, sprintf("%s @ %s", segName, segTag), cex=2.0);
  }
  if (!is.null(tagsT)) {
    tagsT <- fullname(tagsT);
    stext(side=3, pos=1, tagsT, cex=2.0);
  }
  if (!is.null(dataSet) & !is.null(chipType)) {
    stext(side=4, pos=0, sprintf("%s (%s)", dataSet, chipType), cex=1.5);
  }
  if (!is.null(sampleName)) {
    stext(side=4, pos=1, sampleName,  cex=1.5);
  }

  points(ascn, pch=pch, col=col, cex=1);

  if (is.element("dens", anTags)) {
    for (dd in 1:2) {
      d <- density(ascn[,dd], adjust=0.4, from=Clim[1], to=Clim[2], na.rm=TRUE);
      draw(d, lwd=3, col="#666666", side=dd, 
                       height=0.05, scale="relative", xpd=FALSE);
    }
  }
} # plotASCN()



plotTrackC1C2 <- function(ascn, x, muN, pch=".", lwd=3, xlim=NULL, Clim=c(-0.4,3.4), xlab="Position (Mb)", ylab=expression(list(C[1],C[2])), dataSet=NULL, chipType=NULL, sampleName=NULL, chrTag=NULL, segName=NULL, segTag=NULL, tagsT=NULL, ...) {
  if (is.null(xlim)) {
    xlim <- range(x, na.rm=TRUE);
    dx <- diff(xlim);
    xlim[1] <- xlim[1] - 0.05*dx;
    xlim[2] <- xlim[2] + 0.05*dx;
  }

#  par(mar=c(4,5,3,3)+0.1, cex=0.8, cex.lab=2.4, cex.axis=2.2);
#  par(mar=c(5.8,7,3,3)+0.1, mgp=c(4,1.4,0), cex=0.8, cex.lab=3.8, cex.axis=2.8);
  par(mar=c(2.5,2.5,1.1,1)+0.1, tcl=-0.3, mgp=c(1.4,0.4,0), cex=2);
  plot(NA, xlim=xlim, ylim=Clim, xlab=xlab, ylab=ylab, axes=FALSE);
  axis(side=1);
  axis(side=2, at=seq(from=0, to=as.integer(Clim[2]+1L)));
  box();

  # Text annotations
  if (!is.null(chrTag)) {
    stext(side=3, pos=0, chrTag,  cex=1.5);
  } else if (!is.null(segName) & !is.null(segTag)) {
    stext(side=3, pos=0, sprintf("%s @ %s", segName, segTag), cex=2.0);
  }
  if (!is.null(tagsT)) {
    tagsT <- fullname(tagsT);
    stext(side=3, pos=1, tagsT, cex=2.0);
  }
  if (!is.null(dataSet) & !is.null(chipType)) {
#    stext(side=4, pos=0, sprintf("%s (%s)", dataSet, chipType), cex=1.5);
  }
  if (!is.null(sampleName)) {
    stext(side=4, pos=1, sampleName,  cex=1.5);
  }

  hets <- which(muN == 1/2);
  xH <- x[hets];
  c1c2 <- ascn[hets,];
  rr <- which(c1c2[,2] < c1c2[,1]);
  c1c2[rr,] <- c1c2[rr,2:1];

  c1 <- c1c2[,1];
  c2 <- c1c2[,2];

  points(xH, c1, pch=pch, cex=1, col="blue");
  points(xH, c2, pch=pch, cex=1, col="red");

  if (!is.null(segName)) {
    abline(h=median(c1,na.rm=TRUE), lwd=lwd, col="blue");
    abline(h=median(c2,na.rm=TRUE), lwd=lwd, col="red");

    if (is.element("dens", anTags)) {
      d <- density(c1, adjust=0.8, na.rm=TRUE);
      draw(d, lwd=3, col="blue", side=2, height=0.05, scale="relative", xpd=FALSE);
  
      d <- density(c2, adjust=0.8, na.rm=TRUE);
      draw(d, lwd=3, col="red", side=2, height=0.05, scale="relative", xpd=FALSE);
    }
  }

  by <- NULL;
  if (is.element("1Mb", anTags)) {
    by <- 1;
  } else if (is.element("2Mb", anTags)) {
    by <- 2;
  } else if (is.element("5Mb", anTags)) {
    by <- 5;
  }

  if (!is.null(by)) {
    c1s <- binnedSmoothing(c1, xH, by=by);
    c2s <- binnedSmoothing(c2, xH, by=by);
    xOut <- attr(c1s, "xOut");
    lwd <- 4;
    lines(xOut, c1s, lwd=lwd+2, col="white");
    lines(xOut, c2s, lwd=lwd+2, col="white");
    lines(xOut, c1s, lwd=lwd, col="blue");
    lines(xOut, c2s, lwd=lwd, col="red");
  }
} # plotTrackC1C2()


plotTrackTCN <- function(C, x, col=NULL, pch=".", xlim=NULL, Clim=c(-0.4,5.4), ylab="Total CN", xlab="Position (Mb)", dataSet=NULL, chipType=NULL, sampleName=NULL, chrTag=NULL, segName=NULL, segTag=NULL, tagsT=NULL, ...) {
  par(mar=c(2.5,2.5,1.1,1)+0.1, tcl=-0.3, mgp=c(1.4,0.4,0), cex=2);
  plot(x, C, pch=pch, col=col, xlim=xlim, ylim=Clim, xlab=xlab, ylab=ylab, axes=FALSE);
  axis(side=1);
  axis(side=2, at=seq(from=0, to=as.integer(Clim[2]+1L)));
  box();

  # Text annotations
  if (!is.null(chrTag)) {
    stext(side=3, pos=0, chrTag,  cex=1.5);
  } else if (!is.null(segName) & !is.null(segTag)) {
    stext(side=3, pos=0, sprintf("%s @ %s", segName, segTag), cex=2.0);
  }
  if (!is.null(tagsT)) {
    tagsT <- fullname(tagsT);
    stext(side=3, pos=1, tagsT, cex=2.0);
  }
  if (!is.null(dataSet) & !is.null(chipType)) {
#    stext(side=4, pos=0, sprintf("%s (%s)", dataSet, chipType), cex=1.5);
  }
  if (!is.null(sampleName)) {
    stext(side=4, pos=1, sampleName, cex=1.5, line=-0.2);
  }
} # plotTrackTCN()



plotTrackBAF <- function(B, x, col=NULL, pch=".", xlim=NULL, Blim=c(-0.2,+1.2), ylab="BAF", xlab="Position (Mb)", dataSet=NULL, chipType=NULL, sampleName=NULL, chrTag=NULL, segName=NULL, segTag=NULL, tagsT=NULL, ...) {
  par(mar=c(2.5,2.5,1.1,1)+0.1, tcl=-0.3, mgp=c(1.4,0.4,0), cex=2);
  plot(x, B, pch=pch, col=col, xlim=xlim, ylim=Blim, xlab=xlab, ylab=ylab, axes=FALSE);
  axis(side=1);
  axis(side=2, at=c(0, 1/2, 1), label=c(0, "1/2", 1));
  box();

  # Text annotations
  if (!is.null(chrTag)) {
    stext(side=3, pos=0, chrTag,  cex=1.5);
  } else if (!is.null(segName) & !is.null(segTag)) {
    stext(side=3, pos=0, sprintf("%s @ %s", segName, segTag), cex=2.0);
  }
  if (!is.null(tagsT)) {
    tagsT <- fullname(tagsT);
    stext(side=3, pos=1, tagsT, cex=2.0);
  }
  if (!is.null(dataSet) & !is.null(chipType)) {
#    stext(side=4, pos=0, sprintf("%s (%s)", dataSet, chipType), cex=1.5);
  }
  if (!is.null(sampleName)) {
    stext(side=4, pos=1, sampleName, cex=1.5, line=-0.2);
  }
} # plotTrackBAF()



plotTrackDH <- function(B, x, muN, col=NULL, pch=".", xlim=NULL, Blim=c(0,+1.2), ylab="DH", xlab="Position (Mb)", dataSet=NULL, chipType=NULL, sampleName=NULL, chrTag=NULL, segName=NULL, segTag=NULL, tagsT=NULL, ...) {
  par(mar=c(2.5,2.5,1.1,1)+0.1, tcl=-0.3, mgp=c(1.4,0.4,0), cex=2);
  DH <- 2*abs(B - 1/2);
  DH[muN != 1/2] <- NA;
  plot(x, DH, pch=pch, col=col, xlim=xlim, ylim=Blim, xlab=xlab, ylab=ylab, axes=FALSE);
  axis(side=1);
  axis(side=2, at=c(0, 1), label=c(0, 1));
  box();

  # Text annotations
  if (!is.null(chrTag)) {
    stext(side=3, pos=0, chrTag,  cex=1.5);
  } else if (!is.null(segName) & !is.null(segTag)) {
    stext(side=3, pos=0, sprintf("%s @ %s", segName, segTag), cex=2.0);
  }
  if (!is.null(tagsT)) {
    tagsT <- fullname(tagsT);
    stext(side=3, pos=1, tagsT, cex=2.0);
  }
  if (!is.null(dataSet) & !is.null(chipType)) {
#    stext(side=4, pos=0, sprintf("%s (%s)", dataSet, chipType), cex=1.5);
  }
  if (!is.null(sampleName)) {
    stext(side=4, pos=1, sampleName, cex=1.5, line=-0.2);
  }
} # plotTrackDH()




extractCACB <- function(dsList, units, ..., reference=c("auto", "none", "median"), samplesLast=FALSE) {
  # Argument 'reference':
  reference <- match.arg(reference);

  C <- extractMatrix(dsList$total, units=units, ...);
  B <- extractMatrix(dsList$fracB, units=units, ...);
  stopifnot(identical(dim(B), dim(C)));

  if (reference == "auto") {
    verbose && enter(verbose, "Inferring from data set name if CN ratios needs to be calculated");
    hasRatios <- hasTag(dsList$total, "CMTN");
    verbose && cat(verbose, "Has 'CMTN' tag: ", hasRatios);
    reference <- ifelse(hasRatios, "none", "median");
    verbose && cat(verbose, "Inferred argument 'reference': ", reference);
    verbose && exit(verbose);
  }

  if (reference == "median") {
    muC <- matrixStats::rowMedians(C, na.rm=TRUE);
    C <- 2 * C / muC;
  }

  CB <- B*C;
  CA <- C - CB;
  data <- array(c(CA, CB), dim=c(dim(C), 2));
  dimnames(data)[[3]] <- c("A", "B");

  if (samplesLast) {
    data <- aperm(data, perm=c(1,3,2));
  }

  data;
} # extractCACB()


plotMultiArrayCACB <- function(cacb, pch=19, cex=2, ..., Clim=c(-0.2,3.4), xlab=expression(C[A]), ylab=expression(C[B]), dataSet=NULL, chipType=NULL, unitName=NULL, tagsT=NULL) {
  par(mar=c(5.8,7,3,3)+0.1, mgp=c(4,1.4,0), cex=0.8, cex.lab=3.8, cex.axis=2.8);
  plot(NA, xlim=Clim, ylim=Clim, xlab=xlab, ylab=ylab, axes=FALSE);
  for (ss in 1:2) {
    axis(side=ss, at=0:round(max(Clim)+1L));
  }
  box();
  lines(x=c(0,2), y=c(2,0), lty=2, lwd=2, col="#999999");
  lines(x=c(0,Clim[2]), y=c(0,Clim[2]), lty=2, lwd=2, col="#999999");
  lines(x=c(0,0), y=c(0,Clim[2]), lty=2, lwd=2, col="#999999");
  lines(x=c(0,Clim[2]), y=c(0,0), lty=2, lwd=2, col="#999999");

  if (!is.null(unitName)) {
    stext(side=3, pos=0, sprintf("Unit: %s", unitName), cex=1.5);
  }

  if (!is.null(tagsT)) {
    tagsT <- fullname(tagsT);
    stext(side=3, pos=1, tagsT, cex=2.0);
  }

  if (!is.null(dataSet) & !is.null(chipType)) {
    stext(side=4, pos=0, sprintf("%s (%s)", dataSet, chipType), cex=1.5);
  }

  stext(side=4, pos=1, sprintf("n=%d", nrow(cacb)), cex=1.5);

  points(cacb, pch=pch, cex=cex, ...);
} # plotMultiArrayCACB()

##########################################################################
# HISTORY:
# 2011-03-09 [HB]
# o Added option "auto" for argument 'reference' of extractSignals().
# o Created.
###########################################################################

###########################################################################
# Author: Henrik Bengtsson
# Created on: 2010-05-18
# Last updated: 2010-05-18
#
# Data:
# rawData/GSE12702/Mapping250K_Nsp/
#
# URL: http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE12702
###########################################################################

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CalMaTe
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
library("calmate");
library("aroma.core");
verbose <- Arguments$getVerbose(-10, timestamp=TRUE);

dataSet <- "Affymetrix_2006-TumorNormal";
tags <- "ACC,-XY,BPN,-XY,RMA,FLN,-XY";
chipType <- "Mapping250K_Nsp";
dsT <- AromaUnitTotalCnBinarySet$byName(dataSet, tags=tags, chipType=chipType);
print(dsT);

dsB <- AromaUnitFracBCnBinarySet$byName(dataSet, tags=tags, chipType=chipType);
print(dsB);

stopifnot(identical(getNames(dsT), getNames(dsB)));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Study array #1 and chromosome 22
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
array <- 1;
chr <- 17;

chrTag <- sprintf("Chr%02d", chr);

# Extract the array
dfT <- getFile(dsT, array);
dfB <- getFile(dsB, array);
stopifnot(identical(getName(dfT), getName(dfB)));

# Extract the chromosome
ugp <- getAromaUgpFile(dsT);
units <- getUnitsOnChromosome(ugp, chr);
pos <- getPositions(ugp, units=units);

# Extract (total, fracB) signals
total <- extractMatrix(dsT, units=units);
fracB <- extractMatrix(dsB, units=units);
dim <- c(nrow(total), 2, ncol(total));
dimnames <- list(rownames(total), c("total", "fracB"), colnames(total));
naValue <- as.double(NA);
data <- array(naValue, dim=dim, dimnames=dimnames);
data[,"total",] <- total;
data[,"fracB",] <- fracB;

dataC <- calmateByTotalAndFracB(data, verbose=-8);

# Plot
ylim <- c(-0.2, 1.2);
subplots(2, ncol=1);

# Array #1
ii <- 1;
name <- dimnames(dataC)[[3]][ii];

fracB <- RawAlleleBFractions(data[,"fracB",ii], x=pos);
plot(fracB, pch=".", ylim=ylim);
stext(side=3, pos=0, name);
stext(side=3, pos=1, chrTag);

fracBC <- RawAlleleBFractions(dataC[,"fracB",ii], x=pos);
plot(fracBC, pch=".", ylim=ylim);
stext(side=3, pos=0, name);
stext(side=3, pos=1, chrTag);


###########################################################################
# HISTORY:
# 2010-05-18
# o Created.
###########################################################################

###########################################################################
# Title:
# Author: Henrik Bengtsson
###########################################################################

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Loading support files
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Find the pathname and directory of this script
library("R.utils");
pathname <- names(findSourceTraceback())[1];
path <- dirname(pathname);

# Loading include files
sourceTo("R/001.include.R", path=path);



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Choose chip type to study
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
chipTypes <- c("GenomeWideSNP_6", "Human1M-Duo");
if (interactive() && require("R.menu")) {
  chipType <- textMenu(chipTypes, title="Select chip type:", value=TRUE);
} else {
  chipType <- chipTypes[1];
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Choose CalMaTe version
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
flavors <- c("v1", "v2");
if (interactive() && require("R.menu")) {
  flavor <- textMenu(flavors, title="Select CalMaTe version:", value=TRUE);
} else {
  flavor <- flavor[1];
}

figPath <- file.path("figures", chipType);
figPath <- Arguments$getWritablePath(figPath);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setting up data sets
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (chipType == "Human1M-Duo") {
  dataSet <- "hudsonalpha.org_OV.Human1MDuo.1.1.0";
  tags <- "XY";
  chipType <- "Human1M-Duo"
} else if (chipType == "GenomeWideSNP_6") {
  dataSet <- "broad.mit.edu_OV.Genome_Wide_SNP_6.12.6.0";
  tags <- "ASCRMAv2";
  chipType <- "GenomeWideSNP_6";
}


if (!exists("dsCList", mode="list")) {
  dsList <- loadSets(dataSet, tags=tags, chipType=chipType, verbose=verbose);
  dsCList <- loadSets(dataSet, tags=c(tags, "CMTN", flavor, "refs=N"), chipType=chipType, verbose=verbose);
}
verbose && print(verbose, dsList);
verbose && print(verbose, dsCList);


# Sample of interest
sampleName <- "TCGA-23-1027-01";
verbose && cat(verbose, "Sample name: ", sampleName);


# Plot dimensions etc.
xlab <- "Position (Mb)";
ylab <- list(tcn="Copy number", baf="Allele B Fraction");
ylim <- list(tcn=c(0,6), baf=c(-0.1, 1.1));
at <- list(tcn=c(0, 2, 4, 6), baf=c(0, 1/2, 1));

# Default graphical parameters
setOption("devNew/args/par", list(
  mar=c(2.5,2.5,1.1,1)+0.1, mgp=c(1.4,0.4,0), tcl=-0.3,
  cex=2
));

chromosomes <- 1:23;
for (chr in chromosomes) {
  chrTag <- sprintf("Chr%02d", chr);

  verbose && enter(verbose, sprintf("Chromosome #%d ('%s') of %d", chr, chrTag, length(chromosomes)));
  verbose && cat(verbose, "Sample name: ", sampleName);

  verbose && enter(verbose, "Extracting signals");
  data <- extractSignals(dsList, sampleName=sampleName, chromosome=chr, reference="median", verbose=verbose);
  verbose && print(verbose, data);
  verbose && exit(verbose);

  verbose && enter(verbose, "Extracting CalMaTe signals");
  dataC <- extractSignals(dsCList, sampleName=sampleName, chromosome=chr, verbose=verbose);
  verbose && print(verbose, dataC);
  verbose && exit(verbose);


  verbose && enter(verbose, "Plotting");
  # Plot dimensions
  pos <- data$tcn$x;
  x <- pos/1e6;
  xlim <- range(x, na.rm=TRUE);

  for (figTag in c("tcn", "baf")) {
    for (cal in c(FALSE, TRUE)) {
      if (cal) {
        dat <- dataC;
        tagsT <- c(tags, "CMTN");
      } else {
        dat <- data;
        tagsT <- tags;
      }

      tagsF <- c(chrTag, chipType, tagsT, toupper(figTag));
      toPNG(name=sampleName, tags=tagsF, width=840, aspectRatio=1/3, {
        plot(NA, xlim=xlim, ylim=ylim[[figTag]], 
                 xlab=xlab, ylab=ylab[[figTag]], axes=FALSE);
        axis(side=1);
        axis(side=2, at=at[[figTag]]);
        points(dat[[figTag]], pch=".");
        stext(side=3, pos=0, sprintf("%s", sampleName));
        stext(side=3, pos=1, chrTag);
      });
    } # for (cal ...)
  } # for (figTag ...)

  verbose && exit(verbose);
} # for (chr ...)



###########################################################################
# HISTORY:
# 2012-02-19 [HB]
# o Now supporting CalMaTe 'flavor' (calmate >= v0.8.0).
# 2011-03-09 [HB]
# o Created from PN's CalMaTe,Illumina.R script from Nov 2010.
###########################################################################

###########################################################################
# Author: Henrik Bengtsson
# Created on: 2010-05-18
# Last updated: 2010-09-28
#
# Data:
# rawData/GSE12702/Mapping250K_Nsp/
#
# URL: http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE12702
###########################################################################

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CalMaTe
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
library("calmate");
verbose <- Arguments$getVerbose(-10, timestamp=TRUE);

dataSet <- "Affymetrix_2006-TumorNormal";
tags <- "ACC,-XY,BPN,-XY,RMA,FLN,-XY";
chipType <- "Mapping250K_Nsp";
dsT <- AromaUnitTotalCnBinarySet$byName(dataSet, tags=tags, chipType=chipType);
print(dsT);

dsB <- AromaUnitFracBCnBinarySet$byName(dataSet, tags=tags, chipType=chipType);
print(dsB);

stopifnot(identical(getNames(dsT), getNames(dsB)));


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CalMaTe
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dsList <- list(total=dsT, fracB=dsB);
asn <- CalMaTeCalibration(dsList);
print(asn);

ugp <- getAromaUgpFile(dsT);
chr <- 17;
units <- getUnitsOnChromosome(ugp, chr);

dsNList <- process(asn, units=units, verbose=verbose);
print(dsNList);

# Array #ii
ii <- 1;

# Extract raw (TCN,BAF)
df <- getFile(dsList$total, ii);
dfR <- getAverageFile(dsList$total, verbose=verbose);
gamma <- extractRawCopyNumbers(df, logBase=NULL, chromosome=chr);
gammaR <- extractRawCopyNumbers(dfR, logBase=NULL, chromosome=chr);
gamma <- 2*divideBy(gamma, gammaR);
df <- getFile(dsList$fracB, ii);
beta <- extractRawAlleleBFractions(df, chromosome=chr);

# Extract calibrated (TCN,BAF)
dfN <- getFile(dsNList$fracB, ii);
betaN <- extractRawAlleleBFractions(dfN, chromosome=chr);
dfN <- getFile(dsNList$total, ii);
gammaN <- extractRawCopyNumbers(dfN, logBase=NULL, chromosome=chr);

# Plot
subplots(4, ncol=2, byrow=FALSE);
plot(beta);
title(sprintf("%s", getName(beta)));
plot(gamma);
plot(betaN);
title(sprintf("%s (CalMaTe)", getName(betaN)));
plot(gammaN);


###########################################################################
# HISTORY:
# 2010-09-28
# o Added total CN track.
# o Using CalMaTeCalibration formely known CalMaTeNormalization.
# 2010-06-20
# o Created.
###########################################################################
